var debug = require('debug')('hack');
var DockerClient = require('./src/client.js');
var DockerServer = require('./src/server.js');
var base    = require('taskcluster-base');
var assert  = require('assert');
var http    = require('http');
var fs      = require('fs');
var Docker  = require('dockerode-promise');

const PORT = 60171;


var main = async () => {
  var client = new DockerClient({
    url: 'ws://localhost:' + PORT + '/a',
    tty: true,
    command: ['sh'],
  });

  // Execute command
  await client.execute();

  client.resize(process.stdout.rows, process.stdout.columns);

  process.stdout.on('resize', () => {
    client.resize(process.stdout.rows, process.stdout.columns);
  });

  process.stdin.setRawMode(true);
  process.stdin.pipe(client.stdin);
  client.stdout.pipe(process.stdout);
  client.stderr.pipe(process.stderr);

  // Wait for termination
  var code = await new Promise((accept, reject) => {
    client.on('exit', accept);
    client.on('error', reject);
  });
  console.log("\nExit code: " + code);

  client.close();
  process.exit(code);
};

main().catch(err => console.log(err.stack));