var debug = require('debug')('docker-exec-websocket-server:test:testclient');
var DockerClient = require('./src/client.js');
var DockerServer = require('./src/server.js');
var base    = require('taskcluster-base');
var assert  = require('assert');
var http    = require('http');
var fs      = require('fs');
var Docker  = require('dockerode-promise');

const PORT = 60171;
const DOCKER_SOCKET = '/var/run/docker.sock';

var server, dockerServer, container;
var main = async () => {
  var docker = new Docker({socketPath: DOCKER_SOCKET});

  // Create docker container
  container = await docker.createContainer({
    Image: 'ubuntu',
    Cmd: ['sleep', '6000']
  });

  // Start the container
  await container.start();

  // Start server
  server = http.createServer();
  await new Promise(accept => server.listen(PORT, accept));

  // Docker docket socket server
  dockerServer = new DockerServer({
    server: server,
    containerId: container.id,
    path: '/a',
  });
};

main().catch(err => console.log(err.stack));