var debug = require('debug')('hack');
var DockerClient = require('./src/client.js');
var DockerServer = require('./src/server.js');
var base    = require('taskcluster-base');
var assert  = require('assert');
var http    = require('http');
var fs      = require('fs');
var Docker  = require('dockerode-promise');

const PORT = 60171;

function toArrayBuffer(buffer) {
  var ab = new ArrayBuffer(buffer.length);
  var view = new Uint8Array(ab);
  for (var i = 0; i < buffer.length; ++i) {
      view[i] = buffer[i];
  }
  return ab;
}

class FileBrowser {
  constructor(url) {
    this.client = new DockerClient({
      url: url,
      tty: false,
      command: ['sh'],
    });
  }
  connect() {
    return client.execute();
  }
  async list(path) {
    client.stdin.write(toArrayBuffer("ls " + path + "\n"));
  }
};




var main = async () => {
  var client = new DockerClient({
    url: 'ws://localhost:' + PORT + '/a',
    tty: false,
    command: ['sh'],
  });

  // Execute command
  await client.execute();

  console.log("write input:");
  //toArrayBuffer(new Buffer("ls /etc\n"))
  client.stdin.write('echo -n "test"; echo -ne "\nresult=$?\n" >&2;\n');
  //client.stdin.end();

  // Read bytes from stdout
  var stdout = [], stderr = [];
  client.stdout.on('data', b => {
    stdout.push(b);
    console.log("stdout:\n%s\n---", Buffer.concat(stdout).toString());
  });
  client.stderr.on('data', b => {
    stderr.push(b);
    console.log("stderr:\n%s\n---", Buffer.concat(stderr).toString());
  });

  // Wait for termination
  var code = await new Promise((accept, reject) => {
    client.on('exit', accept);
    client.on('error', reject);
  });
  console.log("Exit code: " + code);

  stdout = Buffer.concat(stdout);
  stderr = Buffer.concat(stderr);
  console.log("stdout: '%s'", stdout.toString());
  console.log("stderr: '%s'", stderr.toString());

  assert(code === 0, 'Expected exit code to be zero');

  client.close();
};

main().catch(err => console.log(err.stack));